Public Class Form1

    ' Define a StringDisplayerType delegate to be a pointer to a subroutine
    ' that has a string parameter.
    Private Delegate Sub StringDisplayerType(ByVal str As String)

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' Declare a StringDisplayerType variable.
        Dim m_DisplayStringRoutine As StringDisplayerType

        ' Assign the variable to a subroutine.
        m_DisplayStringRoutine = AddressOf ShowStringInMessageBox ' ShowStringInOutputWindow

        ' Invoke the delegates subroutine.
        m_DisplayStringRoutine("Hello world")
    End Sub

    Private Sub ShowStringInOutputWindow(ByVal str As String)
        Debug.WriteLine(str)
    End Sub

    Private Sub ShowStringInMessageBox(ByVal str As String)
        MessageBox.Show(str)
    End Sub
End Class
