Imports System.Data
Imports System.Data.OleDb

Public Class Form1
    Private Const CONNECT_STRING As String = _
        "Provider=Microsoft.Jet.OLEDB.4.0;" & _
        "Data Source=C:\VB Prog Ref\" & _
            "JulyCTPSrc\Ch11\UseCommand\people.mdb;" & _
        "Persist Security Info=False"

    Private Sub btnAdd_Click(ByVal sender As System.Object, _
     ByVal e As System.EventArgs) Handles btnAdd.Click
        ' Open the connection.
        Dim conn_people As New OleDbConnection(CONNECT_STRING)
        conn_people.Open()

        ' Make a Command to insert data.
        Dim cmd As New OleDbCommand( _
            "INSERT INTO PeopleNames (FirstName, LastName) " & _
            "VALUES (?, ?)", _
            conn_people)

        ' Create parameters for the command.
        cmd.Parameters.Add(New OleDbParameter("FirstName", txtFirstName.Text))
        cmd.Parameters.Add(New OleDbParameter("LastName", txtLastName.Text))

        ' Execute the command.
        Try
            cmd.ExecuteNonQuery()
        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try

        ' Show the data.
        ShowValues(conn_people)

        ' Close the connection.
        conn_people.Close()
        conn_people.Dispose()
    End Sub

    Private Sub ShowValues(ByVal conn_people As OleDbConnection)
        Dim data_adapter As New OleDbDataAdapter( _
            "SELECT FirstName, LastName " & _
                "FROM PeopleNames " & _
                "ORDER BY FirstName, LastName", _
            conn_people)
        Dim data_table As New DataTable()
        data_adapter.Fill(data_table)
        Dim txt As String = ""
        For Each data_row As DataRow In data_table.Rows
            txt &= data_row.Item("FirstName").ToString & _
                " " & data_row.Item("LastName").ToString & vbCrLf
        Next data_row
        lblResults.Text = txt

        data_table.Dispose()
        data_adapter.Dispose()
    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' Open the connection.
        Dim conn_people As New OleDbConnection(CONNECT_STRING)
        conn_people.Open()

        ' Show the data.
        ShowValues(conn_people)

        ' Close the connection.
        conn_people.Close()
        conn_people.Dispose()
    End Sub
End Class
