Public Class Form1

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        MsgBox(calReservation.TodayDateSet)

        ' Set the minimum and maximum dates.
        calReservation.MinDate = #1/1/2006#
        calReservation.MaxDate = #6/30/2006#

        ' Get the first Monday in the allowed range.
        Dim mon As DateTime
        mon = calReservation.MinDate
        Select Case mon.DayOfWeek
            Case DayOfWeek.Tuesday
                mon = mon.AddDays(6)
            Case DayOfWeek.Wednesday
                mon = mon.AddDays(5)
            Case DayOfWeek.Thursday
                mon = mon.AddDays(4)
            Case DayOfWeek.Friday
                mon = mon.AddDays(3)
            Case DayOfWeek.Saturday
                mon = mon.AddDays(2)
            Case DayOfWeek.Sunday
                mon = mon.AddDays(1)
        End Select

        ' Make an array of the allowed Mondays.
        Dim num_mondays As Integer
        Dim mondays() As DateTime = Nothing
        Do While mon <= calReservation.MaxDate
            num_mondays += 1
            ReDim Preserve mondays(num_mondays - 1)
            mondays(num_mondays - 1) = mon
            calReservation.AddBoldedDate(mon)
            mon = mon.AddDays(7)
        Loop

        ' Bold the Mondays.
        calReservation.BoldedDates = mondays

        ' Set today's date to 4/22/2006.
        calReservation.TodayDate = New Date(2006, 4, 22)

        ' Start with the dates 7/28/2005 - 6/30/2005 selected.
        calReservation.SelectionRange = _
            New SelectionRange( _
                New Date(2006, 4, 24), _
                New Date(2006, 4, 27))
    End Sub

    Private Sub btnOk_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOk.Click
        Me.Close()
    End Sub

    Private Sub btnCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCancel.Click
        Me.Close()
    End Sub
End Class
